.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include problem_finder.inc
GetBmpBrushArray PROTO :DWORD,:DWORD,:DWORD,:DWORD
GetBmpArray PROTO :DWORD,:DWORD,:DWORD,:DWORD
prob1       PROTO :DWORD,:DWORD,:DWORD,:DWORD
prob2       PROTO :DWORD,:DWORD,:DWORD,:DWORD
prob3       PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
	rc RECT <20,60,104,162>
	state dd 0
.data?
	hProb1    dd ?
	hProb2    dd ?
	hProb3    dd ?
	hProb4    dd ?
	hInstance dd ?
	pBmp dd 3 dup (?)
	pBmpBrush dd 3 dup (?)
	bmpx      dd ?
	br        dd ?
.code

start:

	invoke GetModuleHandle, 0
	mov	   hInstance, eax

    invoke InitCommonControls
	invoke DialogBoxParam, hInstance, 1000, 0, ADDR DlgProc, 0
	invoke ExitProcess, 0

DlgProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		invoke CreateDialogParam, hInstance, 2000, hWin, ADDR prob1, 0
		mov    hProb1, eax
		invoke CreateDialogParam, hInstance, 3000, hWin, ADDR prob2, 0
		mov    hProb2, eax
		invoke ShowWindow, eax, SW_HIDE
		invoke CreateDialogParam, hInstance, 4000, hWin, ADDR prob3, 0
		mov    hProb3, eax
		invoke ShowWindow, eax, SW_HIDE
		invoke CreateDialogParam, hInstance, 5000, hWin, ADDR prob3, 0
		mov    hProb4, eax
		invoke ShowWindow, eax, SW_HIDE
		
	.elseif eax==WM_COMMAND

	.elseif eax==WM_CLOSE
		invoke EndDialog, hWin, 0
	.else
		mov    eax, 0
		ret
	.endif
	mov    eax, 1
	ret

DlgProc endp

prob1 proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	
	mov    eax, uMsg
	.if eax==WM_INITDIALOG
		invoke LoadBitmap, hInstance, 11100
		mov    bmpx, eax
		invoke GetBmpArray, hWin, bmpx, 34, ADDR pBmp
		invoke SendDlgItemMessage, hWin, 2005, STM_SETIMAGE, IMAGE_BITMAP, [pBmp+0]
		invoke SendDlgItemMessage, hWin, 2006, STM_SETIMAGE, IMAGE_BITMAP, [pBmp+4]
		invoke SendDlgItemMessage, hWin, 2007, STM_SETIMAGE, IMAGE_BITMAP, [pBmp+8]
		
	.elseif eax==WM_COMMAND
		.if wParam==2002
			invoke ShowWindow, hWin,   SW_HIDE
			invoke ShowWindow, hProb2, SW_SHOW
		.endif
	.elseif eax==WM_CLOSE
		invoke DeleteObject, [pBmp+0]
		invoke DeleteObject, [pBmp+4]
		invoke DeleteObject, [pBmp+8]
		invoke DeleteObject, bmpx
		invoke EndDialog, hWin, 0
	.else
		mov    eax, 0
		ret
	.endif
	mov    eax, 1
	ret

prob1 endp

prob2 proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL ps:PAINTSTRUCT
	LOCAL oldb:DWORD
	
	mov    eax, uMsg
	.if eax==WM_INITDIALOG
		invoke LoadBitmap, hInstance, 11100
		mov    bmpx, eax
		invoke GetBmpBrushArray, hWin, bmpx, 34, ADDR pBmpBrush
		invoke DeleteObject, bmpx

	.elseif eax==WM_PAINT
		invoke BeginPaint, hWin, ADDR ps
		invoke SelectObject, ps.hdc, [pBmpBrush+0]
		mov    oldb, eax
		invoke SetBrushOrgEx, ps.hdc, 20, 60, 0
		invoke PatBlt, ps.hdc, 20, 60, 84, 34, PATCOPY
		
		invoke SelectObject, ps.hdc, oldb
		invoke SelectObject, ps.hdc, [pBmpBrush+4]
		mov    oldb, eax
		invoke SetBrushOrgEx, ps.hdc, 40, 94, 0
		invoke PatBlt, ps.hdc, 40, 94, 84, 34, PATCOPY
		
		invoke SelectObject, ps.hdc, oldb
		invoke SelectObject, ps.hdc, [pBmpBrush+8]
		mov    oldb, eax
		invoke SetBrushOrgEx, ps.hdc, 20, 128, 0
		invoke PatBlt, ps.hdc, 20, 128, 84, 34, PATCOPY
		
		invoke SelectObject, ps.hdc, oldb
		invoke EndPaint, hWin, ADDR ps
	.elseif eax==WM_COMMAND
		.if wParam==3001
			invoke ShowWindow, hWin,   SW_HIDE
			invoke SetTimer,   hProb3, 500, 1000, 0
			invoke ShowWindow, hProb3, SW_SHOW
		.endif
	.elseif eax==WM_CLOSE
		invoke DeleteObject, [pBmpBrush+0]
		invoke DeleteObject, [pBmpBrush+4]
		invoke DeleteObject, [pBmpBrush+8]
		invoke EndDialog, hWin, 0
	.else
		mov    eax, 0
		ret
	.endif
	mov    eax, 1
	ret

prob2 endp

prob3 proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL ps:PAINTSTRUCT
	LOCAL oldb:DWORD
	
	mov    eax, uMsg
	.if eax==WM_INITDIALOG
		mov    eax, [pBmpBrush+0]
		mov    br, eax
	.elseif eax==WM_TIMER
		.if state==0
			mov  ecx, [pBmpBrush+0]
			mov  state, 1
		.elseif state==1
			mov  ecx, [pBmpBrush+4]
			mov  state, 2
		.else
			mov  ecx, [pBmpBrush+8]
			mov  state, 0
		.endif
		mov    br, ecx
		invoke InvalidateRect, hWin, ADDR rc, 0
		
	.elseif eax==WM_PAINT
		invoke BeginPaint, hWin, ADDR ps
		invoke SelectObject, ps.hdc, br
		mov    oldb, eax
		invoke SetBrushOrgEx, ps.hdc, 20, 60, 0
		invoke PatBlt, ps.hdc, 20, 60, 84, 34, PATCOPY
		
		invoke SelectObject, ps.hdc, oldb
		invoke SelectObject, ps.hdc, br
		mov    oldb, eax
		invoke SetBrushOrgEx, ps.hdc, 20, 94, 0
		invoke PatBlt, ps.hdc, 20, 94, 84, 34, PATCOPY
		
		invoke SelectObject, ps.hdc, oldb
		invoke SelectObject, ps.hdc, br
		mov    oldb, eax
		invoke SetBrushOrgEx, ps.hdc, 20, 128, 0
		invoke PatBlt, ps.hdc, 20, 128, 84, 34, PATCOPY
		
		invoke SelectObject, ps.hdc, oldb
		invoke EndPaint, hWin, ADDR ps
	.elseif eax==WM_COMMAND
		.if wParam==4003
			invoke KillTimer, hWin, 500
			invoke ShowWindow, hWin,   SW_HIDE
			invoke SetTimer,   hProb4, 600, 1000, 0
			invoke ShowWindow, hProb4, SW_SHOW
		.endif
	.elseif eax==WM_CLOSE
		invoke KillTimer, hWin, 500
		invoke EndDialog, hWin, 0
	.else
		mov    eax, 0
		ret
	.endif
	mov    eax, 1
	ret

prob3 endp

prob4 proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL ps:PAINTSTRUCT
	LOCAL oldb:DWORD
	
	mov    eax, uMsg
	.if eax==WM_INITDIALOG
		mov    eax, [pBmpBrush+0]
		mov    br, eax
	.elseif eax==WM_TIMER
		.if state==0
			mov  ecx, [pBmpBrush+0]
			mov  state, 1
		.elseif state==1
			mov  ecx, [pBmpBrush+4]
			mov  state, 2
		.else
			mov  ecx, [pBmpBrush+8]
			mov  state, 0
		.endif
		mov    br, ecx
		invoke InvalidateRect, hWin, ADDR rc, 1
		
	.elseif eax==WM_PAINT
		invoke BeginPaint, hWin, ADDR ps
		invoke SelectObject, ps.hdc, br
		mov    oldb, eax
		invoke SetBrushOrgEx, ps.hdc, 20, 60, 0
		invoke PatBlt, ps.hdc, 20, 60, 84, 34, PATCOPY
		
		invoke SelectObject, ps.hdc, oldb
		invoke SelectObject, ps.hdc, br
		mov    oldb, eax
		invoke SetBrushOrgEx, ps.hdc, 20, 94, 0
		invoke PatBlt, ps.hdc, 20, 94, 84, 34, PATCOPY
		
		invoke SelectObject, ps.hdc, oldb
		invoke SelectObject, ps.hdc, br
		mov    oldb, eax
		invoke SetBrushOrgEx, ps.hdc, 20, 128, 0
		invoke PatBlt, ps.hdc, 20, 128, 84, 34, PATCOPY
		
		invoke SelectObject, ps.hdc, oldb
		invoke EndPaint, hWin, ADDR ps
	.elseif eax==WM_CLOSE
		invoke KillTimer, hWin, 600
		invoke EndDialog, hWin, 0
	.else
		mov    eax, 0
		ret
	.endif
	mov    eax, 1
	ret

prob4 endp

GetBmpArray proc uses esi hWin:DWORD, hBmp:DWORD, im_y:DWORD, pBmps:DWORD
	LOCAL bmp  :BITMAP
	LOCAL dc   :DWORD
	LOCAL bmpX :DWORD
	LOCAL mdcY :DWORD
	LOCAL mdcX :DWORD
	LOCAL bOld :DWORD
	LOCAL bOldX:DWORD
	
	invoke GetDC, hWin
	mov    dc,   eax
		
	invoke GetObject, hBmp, sizeof BITMAP, ADDR bmp
		
	mov    eax, bmp.bmHeight
	xor    edx, edx
	div    im_y
	mov    esi, eax
		
	invoke CreateCompatibleDC, dc
	mov    mdcY, eax
	invoke CreateCompatibleDC, dc
	mov    mdcX, eax
	invoke SelectObject, mdcX, hBmp
	mov    bOldX, eax
		
	test   esi,  esi
	jz     @exit
	;-----
	@@:
	dec    esi
		
	invoke CreateCompatibleBitmap, dc, bmp.bmWidth, im_y
	mov    bmpX, eax
	invoke SelectObject, mdcY, bmpX
	mov    bOld, eax
	mov    eax,  esi
	mul    im_y
	invoke BitBlt, mdcY, 0, 0, bmp.bmWidth, im_y, mdcX, 0, eax, SRCCOPY
	invoke GetCurrentObject, mdcY, OBJ_BITMAP
	mov    ecx,   esi
	shl    ecx,   2
	add    ecx,   pBmps
	mov    [ecx], eax
	invoke SelectObject, mdcY, bOld
	
	test   esi,   esi
	jnz    @B
	@exit:
	;-----
	invoke SelectObject, mdcX, bOldX
	invoke DeleteDC,     mdcX
	invoke DeleteDC,     mdcY
	invoke ReleaseDC,    hWin, dc
	
	mov    eax, bmp.bmWidth
	ret

GetBmpArray endp

GetBmpBrushArray proc uses esi hWin:DWORD, hBmp:DWORD, im_y:DWORD, pBrushes:DWORD
	LOCAL bmp  :BITMAP
	LOCAL dc   :DWORD
	LOCAL bmpX :DWORD
	LOCAL mdcY :DWORD
	LOCAL mdcX :DWORD
	LOCAL bOld :DWORD
	LOCAL bOldX:DWORD
	
	invoke GetDC, hWin
	mov    dc,   eax
		
	invoke GetObject, hBmp, sizeof BITMAP, ADDR bmp
		
	mov    eax, bmp.bmHeight
	xor    edx, edx
	div    im_y
	mov    esi, eax
		
	invoke CreateCompatibleDC, dc
	mov    mdcY, eax
	invoke CreateCompatibleDC, dc
	mov    mdcX, eax
	invoke SelectObject, mdcX, hBmp
	mov    bOldX, eax
		
	test   esi,  esi
	jz     @exit
	;-----
	@@:
	dec    esi
		
	invoke CreateCompatibleBitmap, dc, bmp.bmWidth, im_y
	mov    bmpX, eax
	invoke SelectObject, mdcY, bmpX
	mov    bOld, eax
	mov    eax,  esi
	mul    im_y
	invoke BitBlt, mdcY, 0, 0, bmp.bmWidth, im_y, mdcX, 0, eax, SRCCOPY
	invoke GetCurrentObject, mdcY, OBJ_BITMAP
	mov    edi, eax
	invoke CreatePatternBrush, edi
	mov    ecx,   esi
	shl    ecx,   2
	add    ecx,   pBrushes
	mov    [ecx], eax
	invoke SelectObject, mdcY, bOld
	invoke DeleteObject, edi
	
	test   esi,   esi
	jnz    @B
	@exit:
	;-----
	invoke SelectObject, mdcX, bOldX
	invoke DeleteDC,     mdcX
	invoke DeleteDC,     mdcY
	invoke ReleaseDC,    hWin, dc
	
	mov    eax, bmp.bmWidth
	ret

GetBmpBrushArray endp

end start
